344d4175791ed1878156b9e0bb9871a0f2d8660a
[Evergreen.git] / Open-ILS / src / extras / Makefile.install
1 # ---------------------------------------------------------------------
2 # Author: Bill Erickson <erickson@esilibrary.com>
3 # Author: Dan Scott <dscott@laurentian.ca>
4 #
5 # Makefile to install prerequisites for OpenSRF and Evergreen
6 #
7 # Currently supports Debian (squeeze), Ubuntu (10.04), Ubuntu (12.04) and
8 # Fedora (16 and 17).
9 #
10 # Installs Perl prereqs, libjs with Perl wrapper, libdbi, libdbi-drivers, and libyaz
11 #
12 # usage:
13 #       make -f Makefile.install debian-squeeze
14 #       - or -
15 #       make -f Makefile.install ubuntu-lucid
16 #       - or -
17 #       make -f Makefile.install ubuntu-precise
18 #       - or -
19 #       make -f Makefile.install fedora
20 #
21 # ---------------------------------------------------------------------
22  
23 # Make any assumptions about the shell being used explicit
24 SHELL=/bin/bash 
25
26 LIBJS=js-1.7.0
27 LIBJS_PERL=JavaScript-SpiderMonkey-0.21
28 LIBJS_URL=http://ftp.mozilla.org/pub/mozilla.org/js/$(LIBJS).tar.gz
29 LIBJS_PERL_URL=http://mirror.datapipe.net/pub/CPAN/authors/id/T/TB/TBUSCH/$(LIBJS_PERL).tar.gz
30 # used for installing libjs lib and header files
31 JS_INSTALL_PREFIX=/usr/
32
33 LIBNET_Z3950_SIMPLESERVER=Net-Z3950-SimpleServer-1.15
34 LIBNET_Z3950_SIMPLESERVER_URL=http://ftp.indexdata.dk/pub/simpleserver/$(LIBNET_Z3950_SIMPLESERVER)
35
36 # The libdbi sources can be fetched from sourceforge.net.  They are stored on
37 # the open-ils.org site now for ease of direct linking
38 LIBDBI=libdbi-0.8.3
39 LIBDBI_DRIVERS=libdbi-drivers-0.8.3
40 LIBDBI_HOST=http://open-ils.org/~denials/evergreen
41
42 # We need a recent version of Yaz
43 # Debian Lenny and Ubuntu 8.10 come with 3.0.34
44 YAZ=yaz-4.2.32
45 YAZ_HOST=http://ftp.indexdata.dk/pub/yaz
46
47 APT_TOOL=aptitude -yq
48 APT_SAFE_TOOL=aptitude -P
49 APT_BACKPORT_TOOL=aptitude -t squeeze-backports -yq
50
51 # Fedora?
52 FEDORA=$(shell uname -r | grep "\.fc[0-9][0-9]\.")
53
54 # Fedora 64-bit?
55 FEDORA_64=$(shell uname -r | grep "\.fc[0-9][0-9]\.x86_64")
56
57 # Debian dependencies
58 DEBS =  \
59         apache2-prefork-dev\
60         aspell\
61         aspell-en\
62         libbusiness-creditcard-perl\
63         libbusiness-onlinepayment-authorizenet-perl\
64         libbusiness-onlinepayment-perl\
65         libdatetime-format-builder-perl\
66         libdatetime-format-iso8601-perl\
67         libdatetime-format-mail-perl\
68         libdatetime-perl\
69         libdatetime-timezone-perl\
70         libdatetime-set-perl\
71         libdbd-pg-perl\
72         libemail-send-perl\
73         libemail-simple-perl\
74         libgd-graph3d-perl\
75         liblog-log4perl-perl\
76         libmarc-record-perl\
77         libncurses5-dev\
78         libnet-ldap-perl \
79         libnet-server-perl\
80         libnet-ssh2-perl\
81         libnspr4-dev\
82         libole-storage-lite-perl\
83         libparent-perl \
84         libreadline5-dev\
85         libspreadsheet-writeexcel-perl\
86         libssh2-1-dev\
87         libtext-aspell-perl\
88         libtext-csv-perl\
89         libuniversal-require-perl\
90         libnet-ip-perl\
91         liblocale-maketext-lexicon-perl\
92         libunix-syslog-perl
93
94 # Debian Lenny and Ubuntu Intrepid bundle recent versions of yaz
95 EXTRA_DEBS = \
96         libbusiness-isbn-perl\
97         libbusiness-isbn-data-perl\
98         libmarc-charset-perl \
99         libmarc-xml-perl \
100         libnet-z3950-zoom-perl \
101         libyaz-dev \
102         yaz
103
104 EXTRA_DEBS_SQUEEZE = \
105     libuuid-tiny-perl
106
107 EXTRA_DEBS_PRECISE = \
108     libdbi-dev \
109     libdbd-pgsql \
110     libmarc-record-perl \
111     libbusiness-edi-perl \
112     liblibrary-callnumber-lc-perl \
113     libsru-perl \
114     libnet-z3950-simple2zoom-perl \
115     libuuid-tiny-perl \
116     libnet-https-any-perl
117
118 FEDORA_RPMS = \
119         aspell \
120         aspell-en \
121         libdbi \
122         libdbi-dbd-pgsql \
123         libdbi-devel \
124         libssh2-devel \
125         libyaz \
126         libyaz-devel \
127         mingw32-nsiswrapper \
128         mod_ssl \
129         ncurses-devel \
130         ncurses-libs \
131         perl-parent \
132         perl-Business-CreditCard \
133         perl-Business-ISBN \
134         perl-Business-ISBN-Data \
135         perl-DBD-Pg \
136         perl-Email-Send \
137         perl-Email-Simple \
138         perl-GDGraph3d \
139         perl-JSON-XS \
140         perl-LDAP \
141         perl-Library-CallNumber-LC \
142         perl-Locale-Codes \
143         perl-MARC-Charset \
144         perl-MARC-Record \
145         perl-Net-IP \
146         perl-Net-SSH2 \
147         perl-OLE-Storage_Lite \
148         perl-Spreadsheet-WriteExcel \
149         perl-Text-Aspell \
150         perl-Text-CSV \
151         perl-Text-CSV_XS \
152         perl-XML-Writer \
153         postgresql-devel \
154         readline-devel \
155         tcp_wrappers-devel \
156         wget \
157         yaz
158
159 # Note: B:O:AuthorizeNet 3.21 fails with https://rt.cpan.org/Public/Bug/Display.html?id=55172
160 # Should be fixed in 3.22
161 # MARC::Record 2.0.1+ is required but only 2.0.0 is packaged
162 FEDORA_CPAN = \
163         Business::OnlinePayment \
164         Business::OnlinePayment::AuthorizeNet \
165         Business::OnlinePayment::PayPal \
166         MARC::File::XML \
167         UUID::Tiny
168
169 PGSQL_90_RPMS = \
170         postgresql90 \
171         postgresql90-contrib \
172         postgresql90-devel \
173         postgresql90-libs \
174         postgresql90-plperl \
175         postgresql90-server
176
177 PGSQL_FEDORA_RPMS = \
178         postgresql \
179         postgresql-contrib \
180         postgresql-libs \
181         postgresql-plperl \
182         postgresql-server
183
184 PGSQL_CLIENT_DEBS_90 = \
185         libpq5 \
186         libpq-dev \
187         postgresql-client-9.0
188
189 PGSQL_CLIENT_DEBS_91 = \
190         libpq5 \
191         libpq-dev \
192         postgresql-client-9.1
193
194 PGSQL_SERVER_DEBS_90 = \
195         postgresql-9.0 \
196         postgresql-contrib-9.0 \
197         postgresql-plperl-9.0 \
198         postgresql-server-dev-9.0
199
200 PGSQL_SERVER_DEBS_91 = \
201         postgresql-9.1 \
202         postgresql-contrib-9.1 \
203         postgresql-plperl-9.1 \
204         postgresql-server-dev-9.1
205
206 DEB_APACHE_MODS = \
207     expires\
208     include\
209     proxy\
210     proxy_http\
211     rewrite
212
213 DEB_APACHE_DISMODS = \
214     deflate
215
216 # Chronically unpackaged CPAN modules
217 CPAN_MODULES = \
218         Business::OnlinePayment::PayPal \
219         Library::CallNumber::LC \
220         Net::Z3950::Simple2ZOOM \
221         Template::Plugin::POSIX \
222         SRU \
223         Rose::URI
224
225 # More chronically unpackaged CPAN modules (available in Squeeze though)
226 CPAN_MODULES_MORE = \
227     Business::CreditCard::Object \
228     MARC::Record \
229     Net::SSH2 \
230     UUID::Tiny
231
232 # Are we sure most distros don't come with an acceptable version of Safe.pm?
233 CPAN_MODULES_SAFE = \
234         Safe
235
236 # Recent Debian/Ubuntus have libmarc-charset-perl, libmarc-xml-perl, libnet-z3950-zoom-perl
237 CPAN_MODULES_MARC = \
238         Business::ISBN \
239         Business::ISBN::Data \
240         MARC::Charset \
241         MARC::File::XML \
242         Net::Z3950::ZOOM
243
244 CPAN_MODULES_MARC_RECORD = \
245         MARC::Record
246
247 CPAN_MODULES_FORCE = \
248         Class::DBI::Frozen::301
249
250 # Lucid Lynx needs the following additional CPAN modules.
251 CPAN_MODULES_LUCID = \
252     RPC::XML::Function
253
254 # Precise Pangolin needs the following CPAN modules. All others are
255 # avaialalbe as debs.
256 CPAN_MODULES_PRECISE = \
257     Business::CreditCard::Object \
258     Business::OnlinePayment::PayPal \
259     Template::Plugin::POSIX \
260     RPC::XML::Function
261
262 # ----------------------------------------------------------------------------
263
264 all: 
265         @echo "please specify an OS" && exit 0
266
267 # these should be the same for any distro
268 install: install_cpan install_js_sm install_cpan_force
269
270 fedora: install_fedora_rpms install_cpan_fedora install_cpan_marc install
271
272 debian-squeeze: squeeze generic_debian
273 squeeze: install_pgsql_client_backport_debs_91  install_extra_debs_squeeze
274 generic_debian: install_debs install_yaz test_for_libdbi_pkg install debian_sys_config install_libdbi
275
276 # Needs for Ubuntu Lucid Lynx (10.04 LTS):
277 ubuntu-lucid: lucid generic_ubuntu
278 lucid: install_pgsql_client_debs_90 install_extra_debs \
279        install_cpan_marc_record install_yaz install_cpan_more \
280        install_cpan_safe install_cpan_lucid install test_for_libdbi_pkg \
281        install_libdbi
282
283 # Needs for Ubuntu Precise Pangolin (12.04 LTS):
284 ubuntu-precise: precise generic_ubuntu
285 precise: install_pgsql_client_debs_91 install_extra_debs_precise \
286          install_cpan_precise install_js_sm install_cpan_force
287
288 # We don't do the "install" target on generic_ubuntu because newer
289 # Ubuntu releases, like newer Debian releases, include packages for
290 # many of those prerequisites.
291 generic_ubuntu: install_debs debian_sys_config
292
293 # - COMMON TARGETS ---------------------------------------------------------
294
295 # Install the CPAN modules
296 install_cpan: install_net_z3950_simpleserver
297         for m in $(CPAN_MODULES); do perl -MCPAN -e "install \"$$m\";"; done
298
299 install_cpan_more: 
300         for m in $(CPAN_MODULES_MORE); do perl -MCPAN -e "install \"$$m\";"; done
301
302 # Install the CPAN modules for MARC functionality
303 install_cpan_marc: install_cpan_marc_record
304         for m in $(CPAN_MODULES_MARC); do perl -MCPAN -e "install \"$$m\";"; done
305
306 install_cpan_marc_record:
307         for m in $(CPAN_MODULES_MARC_RECORD); do perl -MCPAN -e "install \"$$m\";"; done
308
309 install_cpan_force:
310         for m in $(CPAN_MODULES_FORCE); do \
311                 echo "force install $$m" | perl -MCPAN -e shell ;\
312         done
313
314 # Install the Safe Perl module
315 # Is this really unpackaged everywhere except for Fedora?
316 install_cpan_safe: 
317         for m in $(CPAN_MODULES_SAFE); do perl -MCPAN -e "install \"$$m\";"; done
318
319 # Install the CPAN modules for Fedora
320 install_cpan_fedora: 
321         for m in $(FEDORA_CPAN); do \
322                 echo "force install $$m" | perl -MCPAN -e shell;\
323         done
324
325 # Install the CPAN modules needed for Lucid
326 install_cpan_lucid:
327         for m in $(CPAN_MODULES_LUCID); do perl -MCPAN -e "install \"$$m\";"; done
328
329 # Install the CPAN modules needed for Precise
330 install_cpan_precise:
331         for m in $(CPAN_MODULES_PRECISE); do perl -MCPAN -e "install \"$$m\";"; done
332
333 # Install a known working version of YAZ
334 install_yaz:    
335         if [ ! -d $(YAZ) ]; then wget $(YAZ_HOST)/$(YAZ).tar.gz; fi;
336         tar xzf $(YAZ).tar.gz
337         cd $(YAZ) && ./configure && make && make install && ldconfig
338
339 # Install the custom spidermonkey libs and JavaScript-SpiderMonkey Perl modules
340 install_js_sm: install_libjs install_spidermonkey
341
342 install_libjs: 
343         if [ ! -f $(LIBJS).tar.gz ]; then wget $(LIBJS_URL); fi;
344         tar -zxf $(LIBJS).tar.gz
345         cd js/src/ && JS_DIST=/usr make -f Makefile.ref
346         mkdir -p $(JS_INSTALL_PREFIX)/include/js/
347         cp js/src/*.h $(JS_INSTALL_PREFIX)/include/js/
348         cp js/src/*.tbl $(JS_INSTALL_PREFIX)/include/js/
349         if [ ! -z $(FEDORA_64) ]; then \
350                 cp js/src/Linux_All_DBG.OBJ/*.so $(JS_INSTALL_PREFIX)/lib64/ && \
351                 cp js/src/Linux_All_DBG.OBJ/*.a $(JS_INSTALL_PREFIX)/lib64/; \
352         else \
353                 cp js/src/Linux_All_DBG.OBJ/*.so $(JS_INSTALL_PREFIX)/lib/ && \
354                 cp js/src/Linux_All_DBG.OBJ/*.a $(JS_INSTALL_PREFIX)/lib/; \
355         fi;
356         ldconfig
357
358 install_spidermonkey:
359         if [ ! -f $(LIBJS_PERL).tar.gz ]; then wget $(LIBJS_PERL_URL); fi;
360         tar -zxf $(LIBJS_PERL).tar.gz
361         if [ ! -z $(FEDORA_64) ]; then \
362                 sed -i -e 's/"\/usr\/lib"/"\/usr\/lib64"/' $(LIBJS_PERL)/Makefile.PL ; \
363         fi;
364         if [ ! -z $(FEDORA) ]; then \
365                 sed -i -e 's/js32.dll/libjs.so/' $(LIBJS_PERL)/Makefile.PL ; \
366         fi;
367         cd $(LIBJS_PERL) && perl Makefile.PL -E4X && make && make test && make install
368
369 install_net_z3950_simpleserver:
370         if [ ! -f $(LIBNET_Z3950_SIMPLESERVER).tar.gz ]; then wget $(LIBNET_Z3950_SIMPLESERVER_URL).tar.gz; fi;
371         tar -zxf $(LIBNET_Z3950_SIMPLESERVER).tar.gz
372         cd $(LIBNET_Z3950_SIMPLESERVER) && perl Makefile.PL && make && make test && make install
373
374 # On Ubuntu and possibly Debian, the libdbi0 package prevents the 
375 # compiled-from-source version from being used and breaks the install.
376 # This package might get installed depending on the install-time choices
377 # for the distro. Test for its existence; if it's there, throw an error
378 # message and exit.
379 test_for_libdbi_pkg:
380                 @if [ "$$(apt-cache policy libdbi0 | grep Installed | grep none | wc -l)" -eq 0 ]; then \
381                                 echo "*** Detected locally installed libdbi0 package; you must remove this"; \
382                                 echo "*** with a command like 'aptitude remove libdbi0' before proceeding"; \
383                                 echo "*** to successfully install Evergreen."; \
384                                 echo; \
385                                 echo "*** Note: this may break other applications on your system."; \
386                                 exit 0; \
387                 fi;
388
389 # Install libdbi and the postgres drivers
390 install_libdbi:
391         if [ ! -d $(LIBDBI) ]; then wget $(LIBDBI_HOST)/$(LIBDBI).tar.gz; fi;
392         if [ ! -d $(LIBDBI_DRIVERS) ]; then wget $(LIBDBI_HOST)/$(LIBDBI_DRIVERS).tar.gz; fi;
393         tar -zxf $(LIBDBI).tar.gz
394         tar -zxf $(LIBDBI_DRIVERS).tar.gz
395         cd $(LIBDBI) && ./configure --disable-docs && make all install
396         cd $(LIBDBI_DRIVERS) && ./configure  \
397                 --disable-docs --with-pgsql --enable-libdbi && make all install  
398
399 clean:
400         make -C $(LIBDBI) clean
401         make -C $(LIBDBI_DRIVERS) clean
402         make -C $(LIBJS_PERL) clean
403         make -f Makefile.ref -C js/src/ clean
404
405
406 # ------------------------------------------------------------------
407 # - DEBIAN ---------------------------------------------------------
408
409 debian_sys_config: 
410         # link the apache modules in
411         for m in $(DEB_APACHE_MODS); do a2enmod $$m; done;
412         # keep the bad apache modules away
413         for m in $(DEB_APACHE_DISMODS); do a2dismod $$m; done;
414         # refresh the dynamic library cache
415         ldconfig
416
417 # Install the debian-specific dependencies
418 install_debs:
419         $(APT_TOOL) install $(DEBS)
420
421 install_pgsql_client_debs_90:
422         @if [ `$(APT_TOOL) versions libpq5 | grep ^i|sed 's/^i[ \t]*//'|cut -d. -f1` -eq 8 ]; \
423                 then \
424                 echo -e "libpq5 / libpq-dev are installed as part of OpenSRF (a dependency" \
425                 "of apache2-prefork-dev), but these are the 8.4 versions and they" \
426                 "conflict with the 9.0 versions - so remove them, install the pinned" \
427                 "backports of 9.0, then reinstall the apache2-prefork-dev package.\n\n" \
428                 "**WARNING**: Saying 'Yes' to this step will _remove_ any PostgreSQL" \
429                 "databases that might currently exist on this machine." && \
430                 $(APT_SAFE_TOOL) remove libpq5 libpq-dev ; \
431         fi
432         $(APT_BACKPORT_TOOL) install $(PGSQL_CLIENT_DEBS_90)
433         $(APT_TOOL) install apache2-prefork-dev
434
435 install_pgsql_server_debs_90:
436         $(APT_BACKPORT_TOOL) install $(PGSQL_SERVER_DEBS_90)
437
438 install_pgsql_client_backport_debs_91:
439         @if [ `$(APT_TOOL) versions libpq5 | grep ^i|sed 's/^i[ \t]*//'|cut -d. -f1` -eq 8 ]; \
440                 then \
441                 echo -e "libpq5 / libpq-dev are installed as part of OpenSRF (a dependency" \
442                 "of apache2-prefork-dev), but these are the 8.4 versions and they" \
443                 "conflict with the 9.0 versions - so remove them, install the pinned" \
444                 "backports of 9.0, then reinstall the apache2-prefork-dev package.\n\n" \
445                 "**WARNING**: Saying 'Yes' to this step will _remove_ any PostgreSQL" \
446                 "databases that might currently exist on this machine." && \
447                 $(APT_SAFE_TOOL) remove libpq5 libpq-dev ; \
448         fi
449         $(APT_BACKPORT_TOOL) install $(PGSQL_CLIENT_DEBS_91)
450         $(APT_TOOL) install apache2-prefork-dev
451
452 install_pgsql_client_debs_91:
453         $(APT_TOOL) install $(PGSQL_CLIENT_DEBS_91)
454
455 install_pgsql_server_debs_91:
456         $(APT_TOOL) install $(PGSQL_SERVER_DEBS_91)
457
458 install_pgsql_server_backport_debs_91:
459         $(APT_BACKPORT_TOOL) install $(PGSQL_SERVER_DEBS_91)
460
461 # Install the debian-specific dependencies for more modern distros
462 install_extra_debs_squeeze: install_extra_debs
463         $(APT_TOOL) install $(EXTRA_DEBS_SQUEEZE)
464
465 # Install dependencies for Ubuntu 12.04:
466 install_extra_debs_precise: install_extra_debs
467         $(APT_TOOL) install $(EXTRA_DEBS_PRECISE)
468
469 install_extra_debs:
470         $(APT_TOOL) install $(EXTRA_DEBS)
471
472 # ------------------------------------------------------------------
473
474 # FEDORA
475 install_fedora_rpms:
476         yum -y update
477         yum -y install $(FEDORA_RPMS)
478
479 install_fedora_pgsql_server:
480         yum -y install $(PGSQL_FEDORA_RPMS)
481
482 # We need to add /usr/local/lib to the ldconfig list of directories on CentOS,
483 # if it is not already there
484 create_ld_local:
485         if [ "$$(ldconfig -v 2> /dev/null | grep '^/usr/local/lib' | wc -l)" -eq 0 ]; then \
486                 echo '/usr/local/lib' >> /etc/ld.so.conf.d/local.conf; \
487                 ldconfig; \
488         fi;
489
490 # vim:noet:sw=4:ts=4: